<?php
    
define('MODULE_SHIPPING_SMILEPAYC2CP_TEXT_CODE_711C2C','711c2cp'); // 7-11 method code
class smilepayc2cp {
    var $code, $title, $description, $icon, $enabled;
    
  
    



    function __construct() {
      global $order, $db;

      $this->code = 'smilepayc2cp';
      $this->title = MODULE_SHIPPING_SMILEPAYC2CP_TEXT_TITLE;
      $this->description = MODULE_SHIPPING_SMILEPAYC2CP_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_SHIPPING_SMILEPAYC2CP_SORT_ORDER;
      $this->icon = '';
      $this->tax_class = MODULE_SHIPPING_SMILEPAYC2CP_TAX_CLASS;
      $this->enabled = ((MODULE_SHIPPING_SMILEPAYC2CP_STATUS == 'True') ? true : false);

      if ( ($this->enabled == true) && ((int)MODULE_SHIPPING_SMILEPAYC2CP_ZONE > 0) ) {
        $check_flag = false;
        $check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_SHIPPING_SMILEPAYC2CP_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        while (!$check->EOF) {
          if ($check->fields['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check->fields['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = true;
            break;
          }
		$check->MoveNext();  
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }


    function quote($method = '') {
      global $order;

      $free_cost = MODULE_SHIPPING_SMILEPAYC2CP_FREE_COST;
      $free_fee_shipping = false;
      //免運費取得參數
      if(!is_null($free_cost) && !empty( $free_cost) && is_numeric($free_cost))
      {
          if($order->info['subtotal'] > $free_cost)
          {
               $free_fee_shipping = true;
          }


      }
      //免運費設定
      if($free_fee_shipping)
      {
          $_711_cost =0;
      }
      else
      {
          $_711_cost =MODULE_SHIPPING_SMILEPAYC2CP_COST;
      }

      $this->quotes = array('id' => $this->code,
                            'module' => MODULE_SHIPPING_SMILEPAYC2CP_TEXT_TITLE,
                            'methods' => array(
                                                //7-11
                                                array('id' => MODULE_SHIPPING_SMILEPAYC2CP_TEXT_CODE_711C2C,
                                                     'title' => MODULE_SHIPPING_SMILEPAYC2CP_TEXT_711C2C_TITLE,
                                                     'cost' => $_711_cost),
                                                     
                                                     ));

      if ($this->tax_class > 0) {
        $this->quotes['tax'] = twe_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
      }

      if (twe_not_null($this->icon)) $this->quotes['icon'] = twe_image($this->icon, $this->title);

      return $this->quotes;
    }

    //檢查shipping method code是否為取貨付款
    function isC2CShippingMethod($shipping_code)
    {
        if($shipping_code == $this->code.'_'.MODULE_SHIPPING_SMILEPAYC2CP_TEXT_CODE_711C2C)  // 7-11
            return true;
        else
            return false;
    }


    public function getStoreData()
    {
        if(isset($_SESSION['smilepayc2c_store_data']))
            return $_SESSION['smilepayc2c_store_data'];
        else
            return array();

    }
    public function isSelectedStoreData()
    {
        $storedata= $this->getStoreData();
        if(empty( $storedata))
            return false;

        if(
               isset($storedata['storeaddress']) && !empty($storedata['storeaddress']) &&
               isset($storedata['storeid']) && !empty($storedata['storeid'])  &&
               isset($storedata['storename']) && !empty($storedata['storename']) 
        )
            return true;
        return false;
    }

    public function runEmap()
    {
        $url = twe_href_link('smilepay_emap_save.php', '', 'SSL');
      
        $map_url = 'https://emap.presco.com.tw/c2cemap.ashx?eshopid=870&servicetype=1&url='.$url;
        header("Location: ".$map_url);
        exit;
    }

    public function clearStoreData()
    {
        unset( $_SESSION['smilepayc2c_store_data'] );
    }



    function check() {
	global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_SMILEPAYC2CP_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    function install() {
	global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CP_STATUS', 'True', '6', '0', 'twe_cfg_select_option(array(\'True\', \'False\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CP_ALLOWED', '', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CP_COST', '60.00', '6', '0', now())");
       $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CP_FREE_COST', '0', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CP_TAX_CLASS', '0', '6', '0', 'twe_get_tax_class_title', 'twe_cfg_pull_down_tax_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CP_ZONE', '0', '6', '0', 'twe_get_zone_class_title', 'twe_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CP_SORT_ORDER', '0', '6', '0', now())");
     
    }

    function remove() {
	global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_SHIPPING_SMILEPAYC2CP_STATUS', 'MODULE_SHIPPING_SMILEPAYC2CP_COST','MODULE_SHIPPING_SMILEPAYC2CP_FREE_COST','MODULE_SHIPPING_SMILEPAYC2CP_ALLOWED', 'MODULE_SHIPPING_SMILEPAYC2CP_TAX_CLASS', 'MODULE_SHIPPING_SMILEPAYC2CP_ZONE', 'MODULE_SHIPPING_SMILEPAYC2CP_SORT_ORDER');
    }
  }


?>
