<?php
    
define('MODULE_SHIPPING_SMILEPAYC2CUP_TEXT_CODE_711C2C','711c2cup'); // 7-11 method code
class smilepayc2cup {
    var $code, $title, $description, $icon, $enabled;
    
    protected $smse_url='https://ssl.smse.com.tw/api/SPPayment.asp';
    

    function __construct() {
      global $order, $db;

      $this->code = 'smilepayc2cup';
      $this->title = MODULE_SHIPPING_SMILEPAYC2CUP_TEXT_TITLE;
      $this->description = MODULE_SHIPPING_SMILEPAYC2CUP_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_SHIPPING_SMILEPAYC2CUP_SORT_ORDER;
      $this->icon = '';
      $this->tax_class = MODULE_SHIPPING_SMILEPAYC2CUP_TAX_CLASS;
      $this->enabled = ((MODULE_SHIPPING_SMILEPAYC2CUP_STATUS == 'True') ? true : false);

      if ( ($this->enabled == true) && ((int)MODULE_SHIPPING_SMILEPAYC2CUP_ZONE > 0) ) {
        $check_flag = false;
        $check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_SHIPPING_SMILEPAYC2CUP_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        while (!$check->EOF) {
          if ($check->fields['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check->fields['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = true;
            break;
          }
		$check->MoveNext();  
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }
    

    function quote($method = '') {
      global $order;


      $free_cost = MODULE_SHIPPING_SMILEPAYC2CUP_FREE_COST;
      $free_fee_shipping = false;

   
      //免運費取得參數
      if(!is_null($free_cost) && !empty( $free_cost) && is_numeric($free_cost))
      {
          if($order->info['subtotal'] > $free_cost)
          {
               $free_fee_shipping = true;
          }


      }
      //免運費設定
      if($free_fee_shipping)
      {
          $_711_cost =0;
      }
      else
      {
          $_711_cost =MODULE_SHIPPING_SMILEPAYC2CUP_COST;
      }
      $this->quotes = array('id' => $this->code,
                            'module' => MODULE_SHIPPING_SMILEPAYC2CUP_TEXT_TITLE,
                            'methods' => array(
                                                //7-11
                                                array('id' => MODULE_SHIPPING_SMILEPAYC2CUP_TEXT_CODE_711C2C,
                                                     'title' => MODULE_SHIPPING_SMILEPAYC2CUP_TEXT_711C2C_TITLE,
                                                     'cost' => $_711_cost),
                                                     
                                                     ));

      if ($this->tax_class > 0) {
        $this->quotes['tax'] = twe_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
      }

      if (twe_not_null($this->icon)) $this->quotes['icon'] = twe_image($this->icon, $this->title);

      return $this->quotes;
    }

    //檢查shipping method code是否為純取貨
    function isC2CShippingMethod($shipping_code)
    {
        if($shipping_code == $this->code.'_'.MODULE_SHIPPING_SMILEPAYC2CUP_TEXT_CODE_711C2C)  // 7-11
            return true;
        else
            return false;
    }

    //取貨門市選擇
     function run_before_process() 
     {

       global $order,$db,$customer_id ;
  
      if( $this->isC2CShippingMethod($_SESSION['shipping']['id']))
      {
          
          
        if(!isset($_POST['smilepay_emap']) || $_POST['smilepay_emap']!='ok')
        {
           

           $this->runEmap();
          
        }

         if(  !$this->isSelectedStoreData())
         {
            $msg = '門市選擇錯誤，請重新結帳';
            twe_redirect(twe_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode($msg ), 'SSL'));
         }

       }
     }

     //信用卡流程，存post data
    function  run_for_credit_card_before_process()
    {
      global $db,$order ;
     
      $storedata=$this->getStoreData();
     
	
  	//商家代號及參數          
      $DealerCode=MODULE_SHIPPING_SMILEPAYC2CUP_DEALERCODE; 
       
      $Rvg2c=MODULE_SHIPPING_SMILEPAYC2CUP_RVG2C;
      $Verify_key = MODULE_SHIPPING_SMILEPAYC2CUP_VERIFY_KEY;

      if(!empty($DealerCode))
        $DealerCode=trim( $DealerCode);
      if(!empty($Rvg2c))
        $Rvg2c=trim( $Rvg2c);
      if(!empty($Verify_key))
        $Verify_key=trim( $Verify_key);
    //訂單編號計算
 	  $oid_query =$db->Execute("SHOW TABLE STATUS LIKE '" . TABLE_ORDERS ."'");    
	  $oid_array = $oid_query->fields['Auto_increment'];	
	  $oid = date('mdHi')."-".$oid_array;
	  //客戶姓名-地址-消費項目
	  $customer=$order->customer['firstname'].$order->customer['lastname'];
      //$customer=mb_substr($customer,0,5,'utf-8');
	  
	  $street_address = $order->customer['state'] . $order->customer['city'] .  $order->customer['street_address'] ;
    
      $sname=mb_substr($order->products[0]['name'],0,10,'utf-8');


      //post表單

      $data_id=$oid . "-" . substr(($_SESSION['step']+100),1);
      $storedata_fomat="{$storedata['storeid']}/{$storedata['storename']}/{$storedata['storeaddress']}";
      if(!empty($order->delivery['fax']))
        $customer_mobile= $order->delivery['fax'];
      else
        $customer_mobile= $order->delivery['telephone'];
      $pargams =  'Dcvc=' .$DealerCode.
                              '&Rvg2c='. $Rvg2c.            
                              '&Verify_key=' . $Verify_key .  
                                                   
                              '&Data_id=' . $data_id.
                              '&Od_sob=' .$oid . "-" . substr(($_SESSION['step']+100),1).
                              '&Pur_name=' .$customer.
                              '&Address=' . $street_address.
                              '&Email=' .$order->customer['email_address'].
                              '&Mobile_number='.   $customer_mobile.
                              '&Pay_zg=52'.
                              '&Pay_gdry=TW'.
                              '&Tel_number='.$order->delivery['telephone'].               
                              '&Logistics_store='.$storedata_fomat;

       $_SESSION['smilepay_c2cup_for_credit_param']= $pargams;
   

    } 
    function run_for_credit_card_process_save_total($total)
    {
          $_SESSION['smilepay_c2cup_for_credit_param'].='&Amount=' .urlencode(round(intval($total)));     
    }
    //信用卡流程，取號
    function  run_for_credit_card_process()
    {
      $pargams =  $_SESSION['smilepay_c2cup_for_credit_param'];
      $storedata=$this->getStoreData();
      $pargams_tmp=explode ('&' ,  $pargams);

      $pargams_tmp2 =explode ('=' ,  $pargams);
      foreach($pargams_tmp as $item)
      {
          $pargams_tmp2 =explode ('=' ,  $item);
          $pargams_data[$pargams_tmp2[0]]= $pargams_tmp2[1];
      }

    

      $ch1 = curl_init();
	  curl_setopt($ch1, CURLOPT_URL, $this->smse_url);
	  curl_setopt($ch1, CURLOPT_VERBOSE, 1);
	  curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, FALSE);
	  curl_setopt($ch1, CURLOPT_SSL_VERIFYHOST, FALSE);
	  curl_setopt($ch1, CURLOPT_POST, 1);
	  curl_setopt($ch1, CURLOPT_RETURNTRANSFER, 1);
	  curl_setopt($ch1, CURLOPT_POSTFIELDS, $pargams);
	  $string_1 = curl_exec($ch1);
	  curl_close($ch1);
	  $xmls = simplexml_load_string($string_1);
      $result=array();
      if(!is_null($xmls) && !empty($xmls))
      {
       
           $result['Amount'] = $xmls->Amount;
           $result['SmilePayNO'] = $xmls->SmilePayNO;
           $result['Data_id'] = $xmls->Data_id;
           $result['Status'] = $xmls->Status;
           if( $result['Status'] != '1')
              $result['Desc'] = $xmls->Desc;
           $result['Pur_name'] = $pargams_data['Pur_name'];
           $result['Mobile_number'] = $pargams_data['Mobile_number'];
           $result['Storeid']= $storedata['storeid'];
           $result['Storename']= $storedata['storename'];
           $result['Storeaddress']= $storedata['storeaddress'];
      }
      else
      {
          //$Status = "-1000";
          $result['Status'] = '-1000';
          $result['Desc'] = 'Place Order fail.';
          $result['Data_id'] = $pargams_data['Data_id'];
      }

      $_SESSION['smilepay_c2cup_results'] = $result;
      $this->clearStoreData() ;
      
      unset( $_SESSION['smilepay_c2cup_for_credit_param']);

    }


    //一般呼叫於before_process() 
    //請在金流模組proces()前呼叫此函數
    function run_process() 
    {
      global $db,$order ;
      
      $storedata=$this->getStoreData();
     
	
  	//商家代號及參數          
      $DealerCode=MODULE_SHIPPING_SMILEPAYC2CUP_DEALERCODE; 
       
      $Rvg2c=MODULE_SHIPPING_SMILEPAYC2CUP_RVG2C;
      $Verify_key = MODULE_SHIPPING_SMILEPAYC2CUP_VERIFY_KEY;

      if(!empty($DealerCode))
        $DealerCode=trim( $DealerCode);
      if(!empty($Rvg2c))
        $Rvg2c=trim( $Rvg2c);
      if(!empty($Verify_key))
        $Verify_key=trim( $Verify_key);
    //訂單編號計算
 	  $oid_query =$db->Execute("SHOW TABLE STATUS LIKE '" . TABLE_ORDERS ."'");    
	  $oid_array = $oid_query->fields['Auto_increment']-1;	
	  $oid = date('mdHi')."-".$oid_array;
	  //客戶姓名-地址-消費項目
	  $customer=explode(' ',$order->customer['name']);// .$order->customer['lastname'];

      //$customer=mb_substr($customer[0],0,5,'utf-8');
	  $customer=$customer[0].$customer[1];
	  $street_address = $order->customer['state'] . $order->customer['city'] .  $order->customer['street_address'] ;
    
      $sname=mb_substr($order->products[0]['name'],0,10,'utf-8');


      //post表單

      $data_id=$oid . "-" . substr(($_SESSION['step']+100),1);
      $storedata_fomat="{$storedata['storeid']}/{$storedata['storename']}/{$storedata['storeaddress']}";
      if(!empty($order->delivery['fax']))
        $customer_mobile= $order->delivery['fax'];
      else
        $customer_mobile= $order->delivery['telephone'];
      if(isset( $_SESSION['SYMBOL_CURRENCY']['SYMBOL_LEFT']) && !empty($_SESSION['SYMBOL_CURRENCY']['SYMBOL_LEFT']))
        $amount= str_replace( $_SESSION['SYMBOL_CURRENCY']['SYMBOL_LEFT'],'',$order->info['total']);
      else
        $amount= $order->info['total'];
      if(isset( $_SESSION['SYMBOL_CURRENCY']['SYMBOL_RIGHT']) && !empty($_SESSION['SYMBOL_CURRENCY']['SYMBOL_RIGHT']))
        $amount= str_replace( $_SESSION['SYMBOL_CURRENCY']['SYMBOL_RIGHT'],'',$amount);
      if(isset( $_SESSION['SYMBOL_CURRENCY']['THOUSANDS_POINT']) && !empty($_SESSION['SYMBOL_CURRENCY']['THOUSANDS_POINT']))
        $amount= str_replace( $_SESSION['SYMBOL_CURRENCY']['THOUSANDS_POINT'],'',$amount);

      $pargams =  'Dcvc=' .$DealerCode.
                              '&Rvg2c='. $Rvg2c.            
                              '&Verify_key=' . $Verify_key .  
                              '&Amount=' .urlencode(intval(round($amount))).                            
                              '&Data_id=' . $data_id.
                              '&Od_sob=' .$oid . "-" . substr(($_SESSION['step']+100),1).
                              '&Pur_name=' .$customer.
                              '&Address=' . $street_address.
                              '&Email=' .$order->customer['email_address'].
                              '&Mobile_number='.  $customer_mobile.
                              '&Pay_zg=52'.
                              '&Pay_gdry=TW'.
                              '&Tel_number='. $order->delivery['telephone'].               
                              '&Logistics_store='.$storedata_fomat;
        
      //$_SESSION['smilepay711c2c_post_arg'] = $pargams;
      $ch1 = curl_init();
	  curl_setopt($ch1, CURLOPT_URL, $this->smse_url);
	  curl_setopt($ch1, CURLOPT_VERBOSE, 1);
	  curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, FALSE);
	  curl_setopt($ch1, CURLOPT_SSL_VERIFYHOST, FALSE);
	  curl_setopt($ch1, CURLOPT_POST, 1);
	  curl_setopt($ch1, CURLOPT_RETURNTRANSFER, 1);
	  curl_setopt($ch1, CURLOPT_POSTFIELDS, $pargams);
	  $string_1 = curl_exec($ch1);
	  curl_close($ch1);
	  $xmls = simplexml_load_string($string_1);
      $result=array();
      if(!is_null($xmls) && !empty($xmls))
      {
       
           $result['Amount'] = $xmls->Amount;
           $result['SmilePayNO'] = $xmls->SmilePayNO;
           $result['Data_id'] = $xmls->Data_id;
           $result['Status'] = $xmls->Status;
           if( $result['Status'] != '1')
              $result['Desc'] = $xmls->Desc;
           $result['Pur_name'] = $customer;
           $result['Mobile_number'] = $customer_mobile;
           $result['Storeid']= $storedata['storeid'];
           $result['Storename']= $storedata['storename'];
           $result['Storeaddress']= $storedata['storeaddress'];
      }
      else
      {
          //$Status = "-1000";
          $result['Status'] = '-1000';
          $result['Desc'] = 'Place Order fail.';
          $result['Data_id'] = $data_id;
      }

      $_SESSION['smilepay_c2cup_results'] = $result;
      $this->clearStoreData() ;
    }

    //訂單成立後呼叫此函數
    //寫備註
    function run_after_process()
    {
       global $insert_id,$db ;
  		

       $result=  $_SESSION['smilepay_c2cup_results'];
       if($result['Status']=="1")
       {
         

            $admincomments   = sprintf(MODULE_SHIPPING_SMILEPAYC2CUP_ADMIN_COMMENT_SUCCESS,$result['SmilePayNO'],$result['Pur_name'], $result['Mobile_number'],$result['Storename'],$result['Storeid'],$result['Storeaddress']);
         //   $customercomments = sprintf(MODULE_SHIPPING_SMILEPAYCSV_CUSTOMER_COMMENT_SUCCESS,$result['FamiNO'],$result['Amount'],$result['PayEndDate']);
            $comment_status = 'Add';
            $oID=explode ("-", $result['Data_id']);


            $db_result=$db->Execute("select orders_status from " . TABLE_ORDERS . " where orders_id=". $oID[1].";");
            if($db_result->RecordCount()>0)
            {
                $orders_status = $db_result->fields['orders_status'];
                $db->Execute("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID[1] . "', '" .$orders_status . "', now(), '0', '".$admincomments."')");
            }


            
          //  $template=sprintf(MODULE_SHIPPING_SMILEPAY711C2C_RESULT_SUCCESS,$result['Pur_name'], $result['Mobile_number'],$result['Storename'],$result['Storeid'],$result['Storeaddress'],$result['Amount']);
            //$_SESSION['smilepay_results']= $template;

            
       }
       else
       {
           
            $comments   = "狀態碼：".$result['Status']."失敗原因：".$result['Desc'];
            $comment_status = 'Fail';
            $oID=explode ("-", $result['Data_id']);
          
            $db_result=$db->Execute("select orders_status from " . TABLE_ORDERS . " where orders_id=". $oID[1].";");
            if($db_result->RecordCount()>0)
            {
                $orders_status = $db_result->fields['orders_status'];
                $db->Execute("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID[1] . "', '" .$orders_status . "', now(), '0', '".$comments."')");      
            }
           // $db->Execute("update " . TABLE_ORDERS .  " set orders_status='".$orders_status."' ,last_modified = now(),cc_expires ='".$comment_status."'  where orders_id = '" . (int)$oID[1] . "'"); 

            //$template=MODULE_SHIPPING_SMILEPAY711C2C_RESULT_FAILED;
            //$_SESSION['smilepay_results']= $template;

       }
     
    }
    //傳回取貨資訊(html)並清除
    function output_result($clearflag=true)
    {
       $result=  $_SESSION['smilepay_c2cup_results'] ;
       if($result['Status']=="1")
       {
           $template=sprintf(MODULE_SHIPPING_SMILEPAYC2CUP_RESULT_SUCCESS,$result['Pur_name'], $result['Mobile_number'],$result['Storename'],$result['Storeid'],$result['Storeaddress'],$result['Amount']);
           
       }
       else
       {
           $template=MODULE_SHIPPING_SMILEPAYC2CUP_RESULT_FAILED;
       }

       if($clearflag)
       {
           unset( $_SESSION['smilepay_c2cup_results']);
       }
       return   $template;
    }


    //驗證純取貨需要參數(訂單成立前)
    //一般用於金流confirmation()中
    //此函數只可用在checkoutprocess之前
    function pre_validate_order()
    {
        global $order,$HTTP_POST_VARS;
        $DealerCode=MODULE_SHIPPING_SMILEPAYC2CUP_DEALERCODE;
        $Rvg2c = MODULE_SHIPPING_SMILEPAYC2CUP_RVG2C;
        $Verify_key = MODULE_SHIPPING_SMILEPAYC2CUP_VERIFY_KEY;

        $customer_name=$order->delivery['firstname'].$order->delivery['lastname'];
        if(!empty($order->delivery['fax']))
            $customer_mobile= $order->delivery['fax'];
        else
            $customer_mobile= $order->delivery['telephone'];
     

        if( !preg_match("/[^a-zA-Z0-9 ]/",$customer_name))
        {
           $limit_name_number =10;
        }
        else
        {
           $limit_name_number =5;
        }

        if ( $order->info['total'] < 0 ) {
		  $result = false ;
		  $error = 1 ;
		  $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) ;
		  twe_redirect(twe_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
	    } elseif(empty($DealerCode) || empty($Rvg2c) || empty($Verify_key) ){
		  $result = false ;
  		  $error =$this->title."，". MODULE_SHIPPING_SMILEPAYC2CUP_SMILEPAY_ARG_ERROR ;

  		  $payment_error_return = 'error_message=' . urlencode($error) ;
  		  twe_redirect(twe_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
           
	    }
        elseif(mb_strlen($customer_name,"UTF-8") > $limit_name_number) 
        {
          $result = false ;
  		  $error = MODULE_SHIPPING_SMILEPAYC2CUP_VALIDATE_NAME_ERROR ;

  		  $payment_error_return = 'error_message=' . urlencode($error) ;
  		  twe_redirect(twe_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
        }
        elseif(!preg_match("/^[0][9][0-9]{8,8}\$/",$customer_mobile)) //phone
        {
          $result = false ;
  		  $error = MODULE_SHIPPING_SMILEPAYC2CUP_VALIDATE_PHONE_ERROR ;

  		  $payment_error_return = 'error_message=' . urlencode($error) ;
  		  twe_redirect(twe_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
        }
        else
          $result = true ;

   
        
	  return $result ;
    }

    public function getStoreData()
    {
        if(isset($_SESSION['smilepayc2c_store_data']))
            return $_SESSION['smilepayc2c_store_data'];
        else
            return array();

    }
    public function isSelectedStoreData()
    {
        $storedata= $this->getStoreData();
        if(empty( $storedata))
            return false;

        if(
               isset($storedata['storeaddress']) && !empty($storedata['storeaddress']) &&
               isset($storedata['storeid']) && !empty($storedata['storeid'])  &&
               isset($storedata['storename']) && !empty($storedata['storename']) 
        )
            return true;
        return false;
    }

    public function runEmap()
    {
        $url = twe_href_link('smilepay_emap_save.php', '', 'SSL');
      
        $map_url = 'https://emap.presco.com.tw/c2cemap.ashx?eshopid=870&servicetype=1&url='.$url;
        header("Location: ".$map_url);
        exit;
    }

    public function clearStoreData()
    {
        unset( $_SESSION['smilepayc2c_store_data'] );
    }



    function check() {
	global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_SMILEPAYC2CUP_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    function install() {
	global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CUP_STATUS', 'True', '6', '0', 'twe_cfg_select_option(array(\'True\', \'False\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CUP_ALLOWED', '', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CUP_COST', '60.00', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CUP_FREE_COST', '0', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CUP_TAX_CLASS', '0', '6', '0', 'twe_get_tax_class_title', 'twe_cfg_pull_down_tax_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CUP_ZONE', '0', '6', '0', 'twe_get_zone_class_title', 'twe_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CUP_SORT_ORDER', '0', '6', '0', now())");

      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CUP_DEALERCODE', '', '6', '0', now());");  
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CUP_RVG2C', '', '6', '0', now());"); 
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_SHIPPING_SMILEPAYC2CUP_VERIFY_KEY', '', '6', '0', now());"); 
    }

    function remove() {
	global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_SHIPPING_SMILEPAYC2CUP_STATUS', 'MODULE_SHIPPING_SMILEPAYC2CUP_DEALERCODE','MODULE_SHIPPING_SMILEPAYC2CUP_RVG2C','MODULE_SHIPPING_SMILEPAYC2CUP_VERIFY_KEY','MODULE_SHIPPING_SMILEPAYC2CUP_COST','MODULE_SHIPPING_SMILEPAYC2CUP_FREE_COST','MODULE_SHIPPING_SMILEPAYC2CUP_ALLOWED', 'MODULE_SHIPPING_SMILEPAYC2CUP_TAX_CLASS', 'MODULE_SHIPPING_SMILEPAYC2CUP_ZONE', 'MODULE_SHIPPING_SMILEPAYC2CUP_SORT_ORDER');
    }
  }


?>
